import { Meta, Preview, Props, Story } from '@storybook/addon-docs/blocks';
import { DependenciesTable } from 'storybook-addon-deps/blocks';
import { withKnobs, object } from '@storybook/addon-knobs';

import ADetailsCardUi from './ADetailsCardUi.vue';
import AClusterUi from '@/components/ui/core/molecules/ACluster/AClusterUi.vue';
import ABadgeUi from '@/components/ui/core/atoms/ABadge/ABadgeUi.vue';

<Meta
  title="Core/Molecules/ADetailsCardUi"
  component={ADetailsCardUi}
  parameters={{ component: ADetailsCardUi }}
/>

# A-Details-Card-Ui

A card with an optional header and footer, and a content area to show the details of an entity.

<Preview columns={1}>
  <Story name="default" decorators={[withKnobs]}>
    {{
      components: { ADetailsCardUi },
      props: {
        styles: {
          default: () =>
            object(
              'CSS Variables',
              {
                '--a-details-card-ui--max-h': '100%',
                '--a-details-card-ui--max-w': '100%',
                '--a-details-card-ui--px': '1rem',
                '--a-details-card-ui--py': '1.25rem',
                '--a-details-card-ui--bg-color': '#ffffff',
                '--a-details-card-ui--border-width': '4px',
                '--a-details-card-ui--border-color': '#6b7280',
              },
              'Styles'
            ),
        },
      },
      template: `
        <a-details-card-ui :style="styles">
          <div class="text-sm leading-5 text-gray-900">
            Content area
          </div>
        </a-details-card-ui>
      `,
    }}
  </Story>
  <Story name="basic-card">
    {{
      components: { ADetailsCardUi },
      template: `
        <a-details-card-ui>
          <a-stack-l class="reset space-y-1">
            <span class="block text-sm leading-5 font-medium text-gray-500">
              Bio
            </span>
            <span class="block text-sm leading-5 text-gray-900">
              Id semper risus in hendrerit gravida rutrum. Diam quam nulla porttitor massa id neque aliquam.
              Feugiat vivamus at augue eget. Dui id ornare arcu odio ut sem. Sit amet est placerat in.
              Elit ut aliquam purus.
            </span>
          </a-stack-l>
        </a-details-card-ui>
      `,
    }}
  </Story>
  <Story name="with-header">
    {{
      components: { ADetailsCardUi },
      template: `
        <a-details-card-ui>
          <template #header>
            <a-stack-l class="reset space-y-1">
              <h3 class="text-lg leading-6 font-medium text-gray-900">
                Jane Doe
              </h3>
              <p class="max-w-2xl text-sm leading-5 text-gray-500">
                Lead Designer
              </p>
            </a-stack-l>
          </template>
          <template #default>
            <a-stack-l class="reset space-y-1">
              <span class="block text-sm leading-5 font-medium text-gray-500">
                Bio
              </span>
              <span class="block text-sm leading-5 text-gray-900">
                Id semper risus in hendrerit gravida rutrum. Diam quam nulla porttitor massa id neque aliquam.
                Feugiat vivamus at augue eget. Dui id ornare arcu odio ut sem. Sit amet est placerat in.
                Elit ut aliquam purus.
              </span>
            </a-stack-l>
          </template>
        </a-details-card-ui>
      `,
    }}
  </Story>
  <Story name="with-footer">
    {{
      components: { ADetailsCardUi, AClusterUi, ABadgeUi },
      template: `
        <a-details-card-ui>
          <template #default>
            <a-stack-l class="reset space-y-1">
              <span class="block text-sm leading-5 font-medium text-gray-500">
                Bio
              </span>
              <span class="block text-sm leading-5 text-gray-900">
                Id semper risus in hendrerit gravida rutrum. Diam quam nulla porttitor massa id neque aliquam.
                Feugiat vivamus at augue eget. Dui id ornare arcu odio ut sem. Sit amet est placerat in.
                Elit ut aliquam purus.
              </span>
            </a-stack-l>
          </template>
          <template #footer>
            <a-cluster-ui>
              <a-badge-ui>Foo</a-badge-ui>
              <a-badge-ui>Foo-Bar</a-badge-ui>
              <a-badge-ui>Bar</a-badge-ui>
              <a-badge-ui>Bar-Baz</a-badge-ui>
              <a-badge-ui>Baz</a-badge-ui>
            </a-cluster-ui>
          </template>
        </a-details-card-ui>
      `,
    }}
  </Story>
  <Story name="full-card">
    {{
      components: { ADetailsCardUi, AClusterUi, ABadgeUi },
      template: `
        <a-details-card-ui style="--a-details-card-ui--max-h: 50vh">
          <template #header>
            <a-stack-l class="reset space-y-1">
              <h3 class="text-lg leading-6 font-medium text-gray-900">
                Jane Doe
              </h3>
              <p class="max-w-2xl text-sm leading-5 text-gray-500">
                Lead Designer
              </p>
            </a-stack-l>
          </template>
          <template #default>
            <a-stack-l class="reset space-y-1">
              <span class="block text-sm leading-5 font-medium text-gray-500">
                Bio
              </span>
              <span class="block text-sm leading-5 text-gray-900">
                Id semper risus in hendrerit gravida rutrum. Diam quam nulla porttitor massa id neque aliquam.
                Feugiat vivamus at augue eget. Dui id ornare arcu odio ut sem. Sit amet est placerat in.
                Elit ut aliquam purus.
              </span>
            </a-stack-l>
          </template>
          <template #footer>
            <a-cluster-ui>
              <a-badge-ui>Foo</a-badge-ui>
              <a-badge-ui>Foo-Bar</a-badge-ui>
              <a-badge-ui>Bar</a-badge-ui>
              <a-badge-ui>Bar-Baz</a-badge-ui>
              <a-badge-ui>Baz</a-badge-ui>
            </a-cluster-ui>
          </template>
        </a-details-card-ui>
      `,
    }}
  </Story>
</Preview>

## API

<Props of={ADetailsCardUi} />

## Installation

```bash
yarn add -E @bit/adakode.ak-ui.core.molecules.a-details-card
```

Install the component layout dependencies:

```bash
yarn add -E @bit/adakode.ak-ui.core.layouts.a-box
```

Install the scrollbar component classes to use
[customized scrollbars](https://gitlab.com/adakodecoop/coop/adakode-ui/-/blob/master/src/assets/styles/components/a-scrollbar-cs/index.css).

```bash
yarn add -E @bit/adakode.ak-styles.css.components.a-scrollbar-cs
```

## Usage

```html
<!-- Full custom Details Card -->
<a-details-card-ui>
  <template #header>
    <a-stack-l class="reset space-y-1">
      <h3 class="text-lg leading-6 font-medium text-gray-900">
        Applicant Information
      </h3>
      <p class="max-w-2xl text-sm leading-5 text-gray-500">
        Personal details and application.
      </p>
    </a-stack-l>
  </template>

  <template #default>
    <dl class="grid grid-cols-1 col-gap-4 row-gap-8 sm:grid-cols-2">
      <div class="sm:col-span-1">
        <dt class="text-sm leading-5 font-medium text-gray-500">
          Full name
        </dt>
        <dd class="mt-1 text-sm leading-5 text-gray-900">
          Margot Foster
        </dd>
      </div>
      <div class="sm:col-span-1">
        <dt class="text-sm leading-5 font-medium text-gray-500">
          Application for
        </dt>
        <dd class="mt-1 text-sm leading-5 text-gray-900">
          Backend Developer
        </dd>
      </div>
      <div class="sm:col-span-1">
        <dt class="text-sm leading-5 font-medium text-gray-500">
          Email address
        </dt>
        <dd class="mt-1 text-sm leading-5 text-gray-900">
          margotfoster@example.com
        </dd>
      </div>
      <div class="sm:col-span-1">
        <dt class="text-sm leading-5 font-medium text-gray-500">
          Salary expectation
        </dt>
        <dd class="mt-1 text-sm leading-5 text-gray-900">
          $120,000
        </dd>
      </div>
      <div class="sm:col-span-2">
        <dt class="text-sm leading-5 font-medium text-gray-500">
          About
        </dt>
        <dd class="mt-1 text-sm leading-5 text-gray-900">
          Fugiat ipsum ipsum deserunt culpa aute sint do nostrud anim incididunt
          cillum culpa consequat. Excepteur qui ipsum aliquip consequat sint.
          Sit id mollit nulla mollit nostrud in ea officia proident. Irure
          nostrud pariatur mollit ad adipisicing reprehenderit deserunt qui eu.
        </dd>
      </div>
    </dl>
  </template>
</a-details-card-ui>
```

## Customization

There are several ways to customize the look and feel of the component,
depending on the desired scope of the customization.

### Global Customization

To customize the look and feel of **every single instance** of the component
create a css file defining a class named after the kebab-case version of the component name
and define any of the custom properties below:

| CSS variable                        |   default | design token               |
| :---------------------------------- | --------: | :------------------------- |
| `--a-details-card-ui--max-h`        |    `100%` | `theme('maxHeight.full')`  |
| `--a-details-card-ui--max-w`        |    `100%` | `theme('maxWidth.full')`   |
| `--a-details-card-ui--px`           |    `1rem` | `theme('padding.4')`       |
| `--a-details-card-ui--py`           | `1.25rem` | `theme('padding.5')`       |
| `--a-details-card-ui--bg-color`     | `#ffffff` | `theme('colors.white')`    |
| `--a-details-card-ui--border-width` |     `4px` | `theme('borderWidth.4')`   |
| `--a-details-card-ui--border-color` | `#6b7280` | `theme('colors.gray.500')` |

These are the steps:

```bash
mkdir -p src/assets/styles/components/ui/core/molecules && touch $_/ADetailsCardUi.css
```

```css
/* <rootDir>/src/assets/styles/components/index.css */
@import './ui/core/molecules/ADetailsCardUi.css';
```

```css
/* <rootDir>/src/assets/styles/components/ui/core/molecules/ADetailsCardUi.css */
.a-details-card-ui {
  --a-details-card-ui--max-h: theme('maxHeight.full');
  --a-details-card-ui--max-w: theme('maxWidth.full');
  --a-details-card-ui--px: theme('padding.4');
  --a-details-card-ui--py: theme('padding.5');
  --a-details-card-ui--bg-color: theme('colors.white');
  --a-details-card-ui--border-width: theme('borderWidth.4');
  --a-details-card-ui--border-color: theme('colors.gray.500');
}
```

### Scoped Customization

To customize the look and feel of a **group of instances** of the component
augment the specificity of the component class with a scoping data attribute:

```css
/* <rootDir>/src/assets/styles/components/ui/core/molecules/ADetailsCardUi.css */
.a-details-card-ui[data-publish-status='draft'] {
  --a-details-card-ui--border-color: theme('colors.gray.500');
}
.a-details-card-ui[data-publish-status='review'] {
  --a-details-card-ui--border-color: theme('colors.pink.500');
}
.a-details-card-ui[data-publish-status='ready'] {
  --a-details-card-ui--border-color: theme('colors.green.500');
}
```

```html
<!-- <rootDir>/src/components/path/to/the/DraftComponent.vue -->
<a-details-card-ui :data-publish-status="draft">
  <a-center-l>
    <!-- Content status: draft -->
  </a-center-l>
</a-details-card-ui>

<!-- <rootDir>/src/components/path/to/the/ReviewComponent.vue -->
<a-details-card-ui :data-publish-status="review">
  <a-center-l>
    <!-- Content status: review -->
  </a-center-l>
</a-details-card-ui>

<!-- <rootDir>/src/components/path/to/the/ReadyComponent.vue -->
<a-details-card-ui :data-publish-status="ready">
  <a-center-l>
    <!-- Content status: ready -->
  </a-center-l>
</a-details-card-ui>
```

### Instance Customization

To customize the look and feel of a **single instance** of the component
you can define the desired CSS variables inline:

```html
<!-- Using CSS variables -->
<a-details-card-ui
  :style="{
    '--a-details-card-ui--max-h': '100%',
    '--a-details-card-ui--max-w': '100%',
    '--a-details-card-ui--px': '1rem',
    '--a-details-card-ui--py': '1.25rem',
    '--a-details-card-ui--bg-color': '#ffffff',
    '--a-details-card-ui--border-width': '4px',
    '--a-details-card-ui--border-color': '#6b7280',
  }"
>
  <div><!-- Content area --></div>
</a-details-card-ui>
```

or use the proper utility classes after a `reset` class:

```html
<!-- Using utility classes -->
<a-details-card-ui class="reset px-4 bg-white border-t-4">
  <div><!-- Content area --></div>
</a-details-card-ui>
```

## Dependencies

<DependenciesTable
  titleDependencies="Dependencies"
  titleDependents="Dependents"
  of={ADetailsCardUi}
/>

## Links

Source: https://gitlab.com/adakodecoop/coop/adakode-ui/-/tree/master/src/components/ui/core/molecules/ADetailsCard  
Bit: https://bit.dev/adakode/ak-ui/core/molecules/a-details-card
